package ml.active;

import ml.util.config.ReadOnlyConfiguration;

/**
 * <p>Title: Active Learning</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class LearnersFactory {
    public LearnersFactory() {
    }

    public XActiveLearner create(String learner, ReadOnlyConfiguration config) throws
            CreationException {
        XActiveLearner activeLearner = null;

        System.out.println("loading learner: "+learner);
        if (learner.equals(SIMPLE.ID)) {
            activeLearner = new SIMPLE();
        } else if (learner.equals(KFF.ID)) {
            activeLearner = new KFF();
        } else if (learner.equals(SELF_CONF.ID)) {
            activeLearner = new SELF_CONF();
        } else if (learner.equals(BALANCED_EE.ID)) {
            activeLearner = new BALANCED_EE();
        } else {
            throw new CreationException("ILL Learner String: " + learner);
        }

        activeLearner.init(config);
        return activeLearner;
    }
}
