package ml.valid.format;

import java.io.*;

/**
 * <p>Title: Active Learning</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class LibSvmFormatValidator {
    public LibSvmFormatValidator() {
    }

    public boolean validate(String file) throws Exception {
        StringBuffer illLines = new StringBuffer("");
        try {
            LineNumberReader reader = new LineNumberReader(new FileReader(file));
            String line = null;

            int length = -1;

            while ( (line = reader.readLine()) != null) {
                if (length == -1) {
                    length = line.split("\\s").length;
                }
                else {
                    if (length != line.split("\\s").length) {
                        illLines.append(reader.getLineNumber()).append('\n');
                    }
                }
            }
            if (illLines.length()>0) {
                throw new RuntimeException("ILL at lines:\n "+illLines);
            }
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        return true;
    }




    public static void main(String[] args) {
        LibSvmFormatValidator libsvmV = new LibSvmFormatValidator();
        try {
            libsvmV.validate("data/blocks10RGB.libsvm");
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
